/*
	This file is part of lobj.

	lobj is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	lobj is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with lobj.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2008 Lucas Hermann Negri
*/

#include "base64.h"

int lobj_base64_encode(lua_State* L)
{
	luaL_checktype(L, 1, LUA_TSTRING);
	
	/* Get the string and its size */
	size_t len;
	const guchar* str = (guchar*)lua_tolstring(L, 1, &len);
	
	/* Do the conversion */
	gchar* coded = g_base64_encode(str, len);
	
	/* Push and release */
	lua_pushstring(L, coded);
	g_free(coded);
	
	return 1;
}

int lobj_base64_decode(lua_State* L)
{
	luaL_checktype(L, 1, LUA_TSTRING);
	
	/* Decode */
	size_t len;
	guchar* decoded = g_base64_decode(lua_tostring(L, 1), &len); 
	
	/* Push and release */
	lua_pushlstring(L, (gchar*)decoded, len);
	g_free(decoded);
	
	return 1;
}
