/*
	This file is part of lobj.

	lobj is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	lobj is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with lobj.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2008 Lucas Hermann Negri
*/

#include "checksum.h"

int lobj_checksum_get_md5(lua_State* L)
{
	luaL_checktype(L, 1, LUA_TSTRING);
	gchar* sum = g_compute_checksum_for_string(G_CHECKSUM_MD5, lua_tostring(L, 1), lua_strlen(L, 1));
	lua_pushstring(L, sum);
	g_free(sum);
	
	return 1; 
}

int lobj_checksum_get_sha1(lua_State* L)
{
	luaL_checktype(L, 1, LUA_TSTRING);
	gchar* sum = g_compute_checksum_for_string(G_CHECKSUM_SHA1, lua_tostring(L, 1), lua_strlen(L, 1));
	lua_pushstring(L, sum);
	g_free(sum);
	
	return 1;	
}

int lobj_checksum_get_sha256(lua_State* L)
{
	luaL_checktype(L, 1, LUA_TSTRING);
	gchar* sum = g_compute_checksum_for_string(G_CHECKSUM_SHA256, lua_tostring(L, 1), lua_strlen(L, 1));
	lua_pushstring(L, sum);
	g_free(sum);
	
	return 1;
}
